----
-- upsidedown project start: 7.11.2014
-- V1.0: released 11.11.2014
-- V4.00 released 25.10.2016 for LS17
-- release home of driveControl is Modhoster. Upload to other hosters is not allowed.





driveControl = {};
driveControl.Version = 4.10;

local driveControl_directory = g_currentModDirectory;

function driveControl:prerequisitesPresent(specializations)
    return true;
end;

function driveControl:load(xmlFile)
	if g_currentMission.driveControl == nil then
		g_currentMission.driveControl = {};
		g_currentMission.driveControl.useModules = {};
		g_currentMission.driveControl.useModules.shuttle = true;		
		g_currentMission.driveControl.useModules.fourWDandDifferentials = true;
		g_currentMission.driveControl.useModules.cruiseControl = true;
		g_currentMission.driveControl.useModules.showNearestFillLevel = true;
		g_currentMission.driveControl.useModules.pipeCam = true;
		g_currentMission.driveControl.useModules.implementControl = true;		
		g_currentMission.driveControl.useModules.softGas = true;
		g_currentMission.driveControl.useModules.variGear = true;
		g_currentMission.driveControl.useModules.freeSteering = true;
		g_currentMission.driveControl.useModules.inching = true;
		g_currentMission.driveControl.useModules.showMotor = true;
		driveControl:loadConfigFile();		
	end;
	
	self.driveControl = {};
	self.driveControl.noEnterCnt = 0;	
	
	self.driveControl.shuttle = {};
	self.driveControl.shuttle.direction = 1.0;
	self.driveControl.shuttle.onOffCnt = 0;
	self.driveControl.shuttle.isActive = true;
	self.driveControl.shuttle.reverseDirection = false;
		
	
	

	self.driveControl.fourWDandDifferentials = {};
	self.driveControl.fourWDandDifferentials.isSurpressed = false;
	self.driveControl.fourWDandDifferentials.fourWheel = false;
	self.driveControl.fourWDandDifferentials.diffLockFront = false;
	self.driveControl.fourWDandDifferentials.diffLockBack = false;
	self.driveControl.fourWDandDifferentials.fourWheelSet = true; --init differentials at startup
	self.driveControl.fourWDandDifferentials.diffLockFrontSet = true;--init differentials at startup
	self.driveControl.fourWDandDifferentials.diffLockBackSet = true;--init differentials at startup
	self.driveControl.fourWDandDifferentials.orgFuelUsage = 0;
	
		
	
	
	
	self.driveControl.cruiseControl = {};
	self.driveControl.cruiseControl.MODE_STANDARD = 1;
	self.driveControl.cruiseControl.MODE_STOP_FULL = 2;
	self.driveControl.cruiseControl.MODE_STOP_EMPTY = 3;
	self.driveControl.cruiseControl.MODE_PARALLEL = 4;
	self.driveControl.cruiseControl.MODE_MANUALVMAX = 5;
	self.driveControl.cruiseControl.mode = self.driveControl.cruiseControl.MODE_STANDARD;
	
	self.driveControl.showNearestFillLevel = {};
		
	self.driveControl.pipeCam = {};
	self.driveControl.pipeCam.isActive = false;
	
	self.driveControl.implementControl = {};
	
	self.driveControl.freeSteering = {};
	self.driveControl.freeSteering.isActive = false;	
	self.driveControl.freeSteering.autoRotateBackSpeedBackup = self.autoRotateBackSpeed;
	

	
	self.driveControl.softGas = {};
	self.driveControl.softGas.isActive = false;
	self.driveControl.softGas.isOn = false;
	
	driveControl.variGear = {}
	-- self.driveControl.variGear.isActive = false;
	
	driveControl.variGearSmoothAlpha = 0.08;
	
	self.driveControl.Inching = {};
	self.driveControl.Inching.InchingLevel = 1;
	self.driveControl.Inching.acceptsCruiseSpeed = true;
	self.driveControl.Inching.cruiseSpeed = self.cruiseControl.maxSpeed; 
	self.driveControl.Inching.lastValidCruiseSpeed = self.cruiseControl.maxSpeed;
	
	driveControl.showMotor = {}
	-- driveControl.showMotorAutoTurnOff = true;
	
	if not driveControl.overlayArrowUp then 
        		
		driveControl.halfTextW = g_currentMission.cruiseControlTextSize / 2*1.5;
		local iconHeight = g_currentMission.vehicleHudBg.height*.095;
		local iconWidth = iconHeight / g_screenAspectRatio;
		
		
		local x = g_currentMission.vehicleHudBg.x;
		local y = g_currentMission.vehicleHudBg.y;
		local width = g_currentMission.vehicleHudBg.width;
		local height = g_currentMission.vehicleHudBg.height;
		
		
		
		
		driveControl.overlayArrowUp   = Overlay:new("overlayArrowUp",   Utils.getFilename("arrowUp.dds",   driveControl_directory), x  + .03 * width,y+.84*height, iconWidth,iconHeight);
		driveControl.overlayArrowDown = Overlay:new("overlayArrowDown", Utils.getFilename("arrowDown.dds", driveControl_directory), x  + .03 * width,y+.84*height, iconWidth,iconHeight);
    
        --driveControl.overlayArrowUp   = Overlay:new("overlayArrowUp",   Utils.getFilename("arrowUp.dds",   driveControl_directory), x+xIndent-xAdjust,y+h-yIndent-iconHeight+yAdjust, iconWidth,iconHeight);
        --driveControl.overlayArrowDown = Overlay:new("overlayArrowDown", Utils.getFilename("arrowDown.dds", driveControl_directory), x+xIndent-xAdjust,y+h-yIndent-iconHeight+yAdjust, iconWidth,iconHeight);
    
        driveControl.overlayBattery = Overlay:new("overlayBattery", Utils.getFilename("battery.dds", driveControl_directory), x + .28 * width - 0*iconWidth,y + .84*height, iconWidth,iconHeight);        
		driveControl.overlayPreHeat = Overlay:new("overlayPreHeat", Utils.getFilename("preHeat.dds", driveControl_directory), x + .28 * width - 0*iconWidth,y + .84*height, iconWidth,iconHeight);
    
        --driveControl.overlayHandBrake = Overlay:new("overlayHandBrake", Utils.getFilename("handBrake.dds", driveControl_directory), x+w,y+h-yIndent-iconHeight+yAdjust, iconWidth,iconHeight);

        driveControl.overlay4WD             = Overlay:new("overlay4WD",             Utils.getFilename("4wd.dds",            driveControl_directory), x + .5 * width + 0*iconWidth,y + .84*height, iconWidth,iconHeight);
        driveControl.overlayDiffLockFront   = Overlay:new("overlayDiffLockFront",   Utils.getFilename("diffLockFront.dds",  driveControl_directory), x + .5 * width + 1*iconWidth,y + .84*height, iconWidth,iconHeight);
        driveControl.overlayDiffLockBack    = Overlay:new("overlayDiffLockBack",    Utils.getFilename("diffLockBack.dds",   driveControl_directory), x + .5 * width + 2*iconWidth,y + .84*height, iconWidth,iconHeight);
		
		driveControl.overlayCruiseStop100   = Overlay:new("overlayCruiseStop100", Utils.getFilename("stop100.dds", driveControl_directory),             x + .85 * width,y + .05*height, 2*iconWidth,iconHeight);
		driveControl.overlayCruiseStop0   = Overlay:new("overlayCruiseStop0", Utils.getFilename("stop0.dds", driveControl_directory),                   x + .85 * width,y + .05*height, 2*iconWidth,iconHeight);
		driveControl.overlayCruise_parallel   = Overlay:new("overlayCruise_parallel", Utils.getFilename("cruise_parallel.dds", driveControl_directory), x + .85 * width,y + .05*height, 2*iconWidth,iconHeight);
		driveControl.overlayCruise_vmax   = Overlay:new("overlayCruise_vmax", Utils.getFilename("cruise_vmax.dds", driveControl_directory),             x + .85 * width,y + .05*height, 1*iconWidth,iconHeight);
        
		--driveControl.neighborFillLevelTxtX,driveControl.neighborFillLevelTxtY = g_currentMission.fillLevelIconOverlay.x + 6.2*g_currentMission.fillLevelTextOffsetX, y + g_currentMission.fillLevelTextOffsetY;
		driveControl.neighborFillLevelTxtX = g_currentMission.fillLevel1Bar.x + g_currentMission.fillLevel1Bar.width - 2.0*iconWidth;
		driveControl.neighborFillLevelTxtY = g_currentMission.fillLevel1Bar.y - driveControl.halfTextW;
		
		driveControl.overlayFreeSteering    = Overlay:new("overlayFreeSteering",    Utils.getFilename("freeSteering.dds",   driveControl_directory), x + .5 * width + 3*iconWidth,y + .84*height, iconWidth,iconHeight);
    end;
	
	self.driveControl.activeModules = {};
	for field,value in pairs(g_currentMission.driveControl.useModules) do
		self.driveControl.activeModules[field] = value;		
	end;
	self.driveControl.firstRunDone = false;
	self.dCcheckModule = driveControl.dCcheckModule;
	self.dCdeactivateModule = driveControl.dCdeactivateModule;	
	
end;

function driveControl:dCdeactivateModule(module)
	print("driveControl module "..module.." externally turned off for this vehicle")
	self.driveControl.activeModules[module] = false;
end;



function driveControl:postLoad(savegame) 

	if savegame ~= nil then
		self.driveControl.fourWDandDifferentials.fourWheel = Utils.getNoNil(getXMLBool(savegame.xmlFile, savegame.key.."#fourWheel"),false);
		self.driveControl.fourWDandDifferentials.diffLockFront = Utils.getNoNil(getXMLBool(savegame.xmlFile, savegame.key.."#diffLockFront"),false);
		self.driveControl.fourWDandDifferentials.diffLockBack = Utils.getNoNil(getXMLBool(savegame.xmlFile, savegame.key.."#diffLockBack"),false);
	end

end;


-- function driveControl:setIsReverseDriving(reverse,noEventSend)
	-- if self.driveControl ~= nil then
		-- self.driveControl.shuttle.reverseDirection = reverse;
		----------print(self.driveControl.shuttle.reverseDirection)
	-- end;
-- end;

function driveControl:onReverseDirectionChanged(direction)
	if self.driveControl ~= nil then
		self.driveControl.shuttle.reverseDirection = self.reverserDirection  < 0;
	end;
end


function driveControl:dCcheckModule(module)
	if Utils.getNoNil(g_currentMission.driveControl.useModules[module],false) then
		if self ~= nil and self.driveControl ~= nil and self.driveControl.activeModules~= nil then
			return Utils.getNoNil(self.driveControl.activeModules[module],false);
		else
			return true;
		end;
	end;
	return false;
	
	-- print("check module: "..module)
	-- return Utils.getNoNil(g_currentMission.driveControl.useModules[module],false) and Utils.getNoNil(self.driveControl.activeModules[module],false)
end;

function driveControl:loadConfigFile()
	local path = getUserProfileAppPath();
	
	local savegameIndex = g_currentMission.missionInfo.savegameIndex;
	local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
	if savegameFolderPath == nil then
		savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), savegameIndex);
	end;	 
		
	-- if g_dedicatedServerInfo ~= nil or fileExists(savegameFolderPath .. '/driveControl_config.xml')then
		---- print("DEDI or save xml FOUND; DO CHANGED SAVE/LOAD!")
		-- path = savegameFolderPath;
		-- driveControl.savegameFolderPath = path.. '/driveControl_config.xml';
	-- end;
	
	local Xml;
	local file = path.."/driveControl_config.xml";
		
	if fileExists(file) then
		print("loading "..file.." for driveControl-Mod configuration");
		Xml = loadXMLFile("driveControl_XML", file, "driveControl");		
	else
		print("creating "..file.." for driveControl-Mod configuration");
		Xml = createXMLFile("driveControl_XML", file, "driveControl");
	end;
	
	
	local moduleList = {"shuttle", "fourWDandDifferentials","cruiseControl","showNearestFillLevel","pipeCam","implementControl","softGas","showMotor","variGear","freeSteering","inching"};
		
	for _,field in pairs(moduleList) do
		local XmlField = string.upper(string.sub(field,1,1))..string.sub(field,2);
		
		local res = getXMLBool(Xml, "driveControl.Modules."..XmlField);

		if res ~= nil then
			g_currentMission.driveControl.useModules[field] = res;
			if res then
				print("driveControl module "..field.." started")
			else
				print("driveControl module "..field.." not started");
			end;
		else
			setXMLBool(Xml, "driveControl.Modules."..XmlField, true);
			print("driveControl module "..field.." inserted into xml and started");
		end;
	end;

	
	
	
	if g_currentMission.driveControl.useModules.softGas then
		local res = getXMLFloat(Xml, "driveControl.softGas.maxGasOnModifier");
		if res ~= nil then
			driveControl.softGasmaxGasOnModifier  = res;
			print("driveControl softGas maxGasOnModifier set to "..tostring(math.floor(res*100)).."%")
		else
			setXMLFloat(Xml, "driveControl.softGas.maxGasOnModifier", 0.3);
			print("driveControl softGas maxGasOnModifier inserted into xml");
			driveControl.softGasmaxGasOnModifier = 0.3;
		end;
	end;
	
	if g_currentMission.driveControl.useModules.variGear then
		local res = getXMLFloat(Xml, "driveControl.variGear.smoothAlpha");
		if res ~= nil then
			driveControl.variGearSmoothAlpha  = res;
			print("driveControl smoothAlpha set to "..tostring(math.floor(res*100)).."%")
		else
			setXMLFloat(Xml, "driveControl.variGear.smoothAlpha", 0.08);
			print("driveControl variGear smoothAlpha inserted into xml");
			driveControl.variGearSmoothAlpha = 0.08;
		end;
	end;
	
		
	if g_currentMission.driveControl.useModules.showMotor then
		local res = getXMLBool(Xml, "driveControl.showMotor.autoTurnOff");
		if res ~= nil then
			driveControl.showMotorAutoTurnOff  = res;
			print("driveControl motor autoTurnOff set to "..tostring(res))
		else
			setXMLBool(Xml, "driveControl.showMotor.autoTurnOff", true);
			print("driveControl showMotor autoTurnOff inserted into xml");
			driveControl.showMotorAutoTurnOff  = true;
		end;
	end;
	
	
	if g_currentMission.driveControl.useModules.freeSteering then
		local res = getXMLFloat(Xml, "driveControl.freeSteering.analogDeadZone");
		if res ~= nil then
			driveControl.freeSteeringAnalogDeadZone  = res;
			res = getXMLBool(Xml, "driveControl.freeSteering.freeSteeringDoSteerAnalog");
			driveControl.freeSteeringDoSteerAnalog = res;
			if res then
				print("driveControl freeSteering analog input ENABLED");
				print("driveControl freeSteering analog deadzone set to "..tostring(math.floor(driveControl.freeSteeringAnalogDeadZone*100)).."%")
			else
				print("driveControl freeSteering analog input DISABLED");
			end;
			
		else
			setXMLFloat(Xml, "driveControl.freeSteering.analogDeadZone", 0.1);
			setXMLBool(Xml, "driveControl.freeSteering.freeSteeringDoSteerAnalog", true);
			print("driveControl freeSteering inserted into xml");
			driveControl.freeSteeringDoSteerAnalog = true;
			driveControl.freeSteeringAnalogDeadZone = 0.1;
		end;
	end;
	
		
	saveXMLFile(Xml);
	delete(Xml);
end;


function driveControl.driveControlFirstTimeRun(self)
		
	-- if g_currentMission.driveControl.useModules.fourWDandDifferentials then
	if self.dCcheckModule ~= nil and self:dCcheckModule("fourWDandDifferentials") then
		if self.isServer then
			local hasStandardDiff = false;
			if self.differentials ~= nil then
				if table.getn(self.differentials) == 3 then
					local pattern = {true, true, false};
					hasStandardDiff = true;
					for k,differential in pairs(self.differentials) do
						hasStandardDiff = hasStandardDiff and differential.diffIndex1IsWheel==pattern[k] and differential.diffIndex2IsWheel==pattern[k];
					end;				
				end;
			end;
			if hasStandardDiff then
				self.driveControl.fourWDandDifferentials.orgFuelUsage = self.fuelUsage;
			else
				self.driveControl.fourWDandDifferentials.isSurpressed = true; --self.driveControl.fourWDandDifferentials.isSurpressed or not hasStandardDiff; 
			end;
		end;
	end;
	
	
	--implementControl
	if self.dCcheckModule ~= nil and self:dCcheckModule("implementControl") then

		local joints = {};
		for k,joint in pairs(self.attacherJoints) do
			if joint.jointType == AttacherJoints.JOINTTYPE_IMPLEMENT or joint.jointType == AttacherJoints.JOINTTYPE_CUTTER or joint.jointType == AttacherJoints.JOINTTYPE_CUTTERHARVESTER then
				if joint.allowsLowering then
					table.insert(joints,k);
				end;
			end;
		end;

		if table.getn(joints) > 0 and table.getn(joints) < 3 then
			local pos = {};
			for _,index in pairs(joints) do
				local x,y,z = getWorldTranslation(self.attacherJoints[index].jointTransform);
				local rx,ry,rz = worldToLocal(self.rootNode,x,y,z);
				pos[index] = rz;
			end;
			if table.getn(joints) == 1 then
				if pos[joints[1]] > 0 then
					self.driveControl.implementControl.front = joints[1];
				else
					self.driveControl.implementControl.back = joints[1];
				end;
			elseif table.getn(joints) == 2 then
				if pos[joints[1]] >  pos[joints[2]] then
					self.driveControl.implementControl.front = joints[1];
					self.driveControl.implementControl.back = joints[2];				 
				else
					self.driveControl.implementControl.front = joints[2];
					self.driveControl.implementControl.back = joints[1];							
				end;
			end;
		end;
	end;
	
	joints = {};
	for k,joint in pairs(self.attacherJoints) do
		if joint.jointType == AttacherJoints.JOINTTYPE_TRAILER then --or joint.jointType == Vehicle.JOINTTYPE_TRAILERLOW then			
			table.insert(joints,k);			
		end;
	end;

	if table.getn(joints) == 1 then
		self.driveControl.implementControl.back2 = joints[1];
	elseif table.getn(joints) == 2 then
		local pos = {};
		for _,index in pairs(joints) do
			local x,y,z = getWorldTranslation(self.attacherJoints[index].jointTransform);
			local rx,ry,rz = worldToLocal(self.rootNode,x,y,z);
			pos[index] = rz;
		end;
		if pos[joints[1]] >  pos[joints[2]] then
			self.driveControl.implementControl.back2 = pos[joints[2]];
		else
			self.driveControl.implementControl.back2 = pos[joints[1]];
		end;
	end;

	
	joints = {};
	for k,joint in pairs(self.attacherJoints) do
		if joint.jointType == AttacherJoints.JOINTTYPE_TRAILERLOW then --or joint.jointType == Vehicle.JOINTTYPE_TRAILERLOW then			
			table.insert(joints,k);			
		end;
	end;

	if table.getn(joints) == 1 then
		self.driveControl.implementControl.back3 = joints[1];
	elseif table.getn(joints) == 2 then
		local pos = {};
		for _,index in pairs(joints) do
			local x,y,z = getWorldTranslation(self.attacherJoints[index].jointTransform);
			local rx,ry,rz = worldToLocal(self.rootNode,x,y,z);
			pos[index] = rz;
		end;
		if pos[joints[1]] >  pos[joints[2]] then
			self.driveControl.implementControl.back3 = pos[joints[2]];
		else
			self.driveControl.implementControl.back3 = pos[joints[1]];
		end;
	end;
end;




function driveControl:onLeave()
	
	
	
	
	-- self.axisForward = 0;
	-- if self.isServer then
		-- Drivable.updateVehiclePhysics(self, 0, false, 0, false, true, 15)
	-- end;
end;


function driveControl:onEnter()
	
end;

function driveControl:mouseEvent(posX, posY, isDown, isUp, button)
end;

function driveControl:keyEvent(unicode, sym, modifier, isDown)
end;

function driveControl:updateTick(dt)
	
	if self.dCcheckModule ~= nil and self:dCcheckModule("showMotor") then
		-- print(tostring(driveControl.showMotorAutoTurnOff))
		if not driveControl.showMotorAutoTurnOff then
			-- print("b")
			if self.motorStopTimer ~= nil then
				-- print("c")
				self.motorStopTimer = self.motorStopTimerDuration;
			end;
		end;
	end;

	if self.dCcheckModule ~= nil and self:dCcheckModule("inching") then
		if self.isEntered and self.isClient then
			if self.steeringEnabled then			
				if self.driveControl.Inching.InchingLevel < 1.0 then
					if self.driveControl.Inching.acceptsCruiseSpeed then
						self.driveControl.Inching.cruiseSpeed = self.driveControl.Inching.lastValidCruiseSpeed; --V1.1					
						self.driveControl.Inching.acceptsCruiseSpeed = false;
					end;
					local newSpeed = self.driveControl.Inching.InchingLevel*self.driveControl.Inching.cruiseSpeed;
					if self.cruiseControl.speedSent ~= newSpeed then
						self:setCruiseControlMaxSpeed(newSpeed);
					end;
				else
					if not self.driveControl.Inching.acceptsCruiseSpeed then --V1.1
						self:setCruiseControlMaxSpeed(self.driveControl.Inching.lastValidCruiseSpeed);
						self.driveControl.Inching.acceptsCruiseSpeed = true; 
					end;				
					self.driveControl.Inching.lastValidCruiseSpeed = self.cruiseControl.speed; --V1.1
				end;			
			end;
		end;
	end;
		
		
	if self.dCcheckModule ~= nil and self:dCcheckModule("fourWDandDifferentials") and not self.driveControl.fourWDandDifferentials.isSurpressed then	
		if self.isServer then
			if self.driveControl.fourWDandDifferentials.fourWheel ~= self.driveControl.fourWDandDifferentials.fourWheelSet then
				if self.driveControl.fourWDandDifferentials.fourWheel then
					-- updateDifferential(self.rootNode,2,self.differentials[3].torqueRatio,self.differentials[3].maxSpeedRatio*1000); --reset 4wd (ON)
					updateDifferential(self.rootNode,2,self.differentials[3].torqueRatio,1.0); --reset 4wd (ON) --Slomo edition
				else
					updateDifferential(self.rootNode,2,0,0) --4wd off, traction to back
				end;		
				self.driveControl.fourWDandDifferentials.fourWheelSet = self.driveControl.fourWDandDifferentials.fourWheel;
			end;
			
			if self.driveControl.fourWDandDifferentials.diffLockFront ~= self.driveControl.fourWDandDifferentials.diffLockFrontSet then
				if self.driveControl.fourWDandDifferentials.diffLockFront then
					updateDifferential(self.rootNode,0,0.5,1.0)  --differential lock front
				else
					updateDifferential(self.rootNode,0,self.differentials[1].torqueRatio,self.differentials[1].maxSpeedRatio*1000); --reset diff-lock front
				end;		
				self.driveControl.fourWDandDifferentials.diffLockFrontSet = self.driveControl.fourWDandDifferentials.diffLockFront;
			end;
			
			if self.driveControl.fourWDandDifferentials.diffLockBack ~= self.driveControl.fourWDandDifferentials.diffLockBackSet then
				if self.driveControl.fourWDandDifferentials.diffLockBack then
					updateDifferential(self.rootNode,1,0.5,1.0) --differential lock back
				else
					updateDifferential(self.rootNode,1,self.differentials[2].torqueRatio,self.differentials[2].maxSpeedRatio*1000); --reset diff-lock front (ON)
				end;
				self.driveControl.fourWDandDifferentials.diffLockBackSet = self.driveControl.fourWDandDifferentials.diffLockBack;
			end;
		end;
		local factor = 1.0;
		if self.driveControl.fourWDandDifferentials.fourWheel then
			factor = factor*1.03;
		end;
		if self.driveControl.fourWDandDifferentials.diffLockFront then
			factor = factor*1.06;
		end;
		if self.driveControl.fourWDandDifferentials.diffLockBack then
			factor = factor*1.06;
		end;
		if self:getIsActive(false) then
			-- print(self.fuelFillLevel)
			-- print(self.fuelUsage*1e6)
			-- self.fuelUsage = self.driveControl.fourWDandDifferentials.orgFuelUsage * factor;
			-- print(self.fuelUsage*1e6)
			-- print("==========")
		end;
	end;
		
end;

function driveControl.toggleAttacherJoint(self,index,noEventSend)

	local jointDesc = self.attacherJoints[index];
	local implementIndex = self:getImplementIndexByJointDescIndex(index);
	
	local implement = self.attachedImplements[implementIndex];
	if implement == nil then
		return false
	end;
	local object = implement.object;
	if object == nil then
		return false
	end;
	
	if object.isPickupLowered~= nil and object.setPickupState~= nil then
		object.setPickupState(object, not object.isPickupLowered)
		return true;
	end;

	
	
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(driveControlToggleImplementEvent:new(self, index), nil, nil, self)
		else
			g_client:getServerConnection():sendEvent(driveControlToggleImplementEvent:new(self, index))
		end
	end

	local moveDown = not object:isLowered();	
	if object.getToggledFoldMiddleDirection~= nil then
		local direction = object.getToggledFoldMiddleDirection(object)		
	end;

	self.lowerImplementByJointIndex(self, index, moveDown)	
	return true
end;

function driveControl.turnOnOffAttacherJoint(self,index)

	local jointDesc = self.attacherJoints[index];
	local implementIndex = self:getImplementIndexByJointDescIndex(index);
	
	local implement = self.attachedImplements[implementIndex];
	if implement == nil then
		return false
	end;
	local object = implement.object;
	if object == nil then
		return false
	end;
	
	if object.setIsTurnedOn~= nil and object.turnOnVehicle.isTurnedOn~= nil then
		object:setIsTurnedOn(not object.turnOnVehicle.isTurnedOn)
		return true;
	elseif jointDesc.jointType == AttacherJoints.JOINTTYPE_CUTTER or jointDesc.jointType == AttacherJoints.JOINTTYPE_CUTTERHARVESTER then		
		if self.setIsTurnedOn~= nil and self.turnOnVehicle.isTurnedOn~= nil then
			self:setIsTurnedOn(not self.turnOnVehicle.isTurnedOn)
			return true;
		end;
	end;
	return false;

end;



function driveControl:update(dt)
	
	if not self.driveControl.firstRunDone then
		-- print("try run")
		driveControl.driveControlFirstTimeRun(self);
		self.driveControl.firstRunDone = true;
	end;
	
	if self.dCcheckModule ~= nil and self:dCcheckModule("inching") then
		if self.isEntered and self.isClient then
			if self.steeringEnabled then
				
				local axis = 0;
				local isAnalog = false;
				local inchingMin = 0.4;
				
				axis = InputBinding.getDigitalInputAxis(InputBinding.driveControlInching);
				if InputBinding.isAxisZero(axis) then
					axis = InputBinding.getAnalogInputAxis(InputBinding.driveControlInching)
					if not InputBinding.isAxisZero(axis) then
						isAnalog = true;
					
						if axis > 0 then
							inchingMin = 0;
						end;
						self.driveControl.Inching.InchingLevel = 1-math.abs(axis);
					end
				else
					isAnalog = false;
				end;
				
				if not isAnalog then
					if axis ~= 0 then
						self.driveControl.Inching.InchingLevel = self.driveControl.Inching.InchingLevel - dt*0.003;
					elseif self.driveControl.Inching.InchingLevel < 1 then
						self.driveControl.Inching.InchingLevel = self.driveControl.Inching.InchingLevel + 0.7*dt*0.001;				
					end
					
				end;			
				
				self.driveControl.Inching.InchingLevel = Utils.clamp(self.driveControl.Inching.InchingLevel,inchingMin,1);
							
			end
		end
	end;
	
	if self.dCcheckModule ~= nil and self:dCcheckModule("softGas") then	
		if g_currentMission.controlledVehicle == self then
			if InputBinding.isPressed(InputBinding.driveControlSoftGas) then
				if not self.driveControl.softGas.isOn then
					self.driveControl.softGas.isOn = true;
					driveControlInputEvent.sendEvent(self) 
				end;
			else
				if self.driveControl.softGas.isOn then
					self.driveControl.softGas.isOn = false;
					driveControlInputEvent.sendEvent(self)
				end;
			end;
		end;
	end;
	
	if self.dCcheckModule ~= nil and self:dCcheckModule("freeSteering") then	
		if g_currentMission.controlledVehicle == self then
			if InputBinding.hasEvent(InputBinding.driveControlFreeSteering) then
				self.driveControl.freeSteering.isActive = not self.driveControl.freeSteering.isActive;
				driveControlInputEvent.sendEvent(self)  
			end;
		end;
	end;	
	
	if self.dCcheckModule ~= nil and self:dCcheckModule("implementControl") then	
		if g_currentMission.controlledVehicle == self then
			if InputBinding.hasEvent(InputBinding.driveControlImplementFront) then
				
				if self.driveControl.implementControl.front~= nil then
					driveControl.toggleAttacherJoint(self,self.driveControl.implementControl.front)
				end;
			end;
			if InputBinding.hasEvent(InputBinding.driveControlImplementBack) then
				
				-- if self.driveControl.implementControl.back~= nil then
					local joints = {self.driveControl.implementControl.back, self.driveControl.implementControl.back2, self.driveControl.implementControl.back3};
					for kkk,joint in pairs(joints) do
						--print(kkk)
						if joint~= nil then							
							local done = driveControl.toggleAttacherJoint(self,joint);
							if done then
								break;
							end;
						end;
					end;
				-- end;
			end;
			if InputBinding.hasEvent(InputBinding.driveControlImplementFrontOnOff) then
				if self.driveControl.implementControl.front~= nil then
					driveControl.turnOnOffAttacherJoint(self,self.driveControl.implementControl.front)
				end;
			end;
			if InputBinding.hasEvent(InputBinding.driveControlImplementBackOnOff) then
				local joints = {self.driveControl.implementControl.back, self.driveControl.implementControl.back2, self.driveControl.implementControl.back3};
				for _,joint in pairs(joints) do
					if joint~= nil then							
						local done = driveControl.turnOnOffAttacherJoint(self,joint);
						if done then
							break;
						end;
					end;
				end;
			
				-- if self.driveControl.implementControl.back~= nil then
					-- driveControl.turnOnOffAttacherJoint(self,self.driveControl.implementControl.back)
				-- end;
			end;			
		end;
	end;
	
	
	if self.dCcheckModule ~= nil and self:dCcheckModule("cruiseControl") then
		if g_currentMission.controlledVehicle == self and self.cruiseControl.state > 0 then	
			local rootVehicle = self:getRootAttacherVehicle();
			
			if self.driveControl.cruiseControl.mode == self.driveControl.cruiseControl.MODE_STOP_FULL then
				local fillLevelInformations = {}; --changed for LS17
				if rootVehicle.getFillLevelInformation~= nil then
					rootVehicle:getFillLevelInformation(fillLevelInformations);
					local allFull = true;
					for i,fillLevelInformation in pairs(fillLevelInformations) do
						if fillLevelInformation.fillLevel < fillLevelInformation.capacity then
							allFull = false;
							break;
						end				
					end
					if allFull then
						self:setCruiseControlState(0);
					end
				end
				
				self.driveControl.cruiseControl.refVehicle = nil;
			elseif self.driveControl.cruiseControl.mode == self.driveControl.cruiseControl.MODE_STOP_EMPTY then
				local fillLevelInformations = {}; --changed for LS17
				if rootVehicle.getFillLevelInformation~= nil then
					rootVehicle:getFillLevelInformation(fillLevelInformations);
					local allEmpty = true;
					for i,fillLevelInformation in pairs(fillLevelInformations) do
						if fillLevelInformation.fillLevel > 0 then
							allEmpty = false;
							break;
						end				
					end
					if allEmpty then
						self:setCruiseControlState(0);
					end
				end;
				
				self.driveControl.cruiseControl.refVehicle = nil;
			elseif self.driveControl.cruiseControl.mode == self.driveControl.cruiseControl.MODE_PARALLEL then
				
				if self.driveControl.cruiseControl.refVehicle == nil then					
					local nearestOther = driveControl.getNearestOther(self);					
					if nearestOther~= nil then
						self.driveControl.cruiseControl.refVehicle = nearestOther;
					end;
				end;
				
				if self.driveControl.cruiseControl.refVehicle~= nil then
					local dx, _, dz = localDirectionToWorld(rootVehicle.rootNode, 0, 0, 1)
					if self.driveControl.cruiseControl.refVehicle.rootNode~= nil then
						local sdx, _, sdz = localDirectionToWorld(self.driveControl.cruiseControl.refVehicle.rootNode, 0, 0, 1)
						if sdx ~= nil then
							local diffAngle = (dx*sdx + dz*sdz)/(math.sqrt(dx^2+dz^2)*math.sqrt(sdx^2+sdz^2))
							diffAngle = math.acos(diffAngle);
							
							if diffAngle > math.rad(20) then
								self:setCruiseControlState(0);
							end;
							
							local inputW = InputBinding.getDigitalInputAxis(InputBinding.AXIS_CRUISE_CONTROL)
							if InputBinding.isAxisZero(inputW) then
								inputW = InputBinding.getAnalogInputAxis(InputBinding.AXIS_CRUISE_CONTROL)
							end

							if self.cruiseControl.state > 0 then
								self:setCruiseControlMaxSpeed(self.driveControl.cruiseControl.refVehicle.lastSpeed*3600/math.cos(diffAngle)+6*inputW);
								self.cruiseControl.wasSpeedChanged = true;
								self.cruiseControl.changeCurrentDelay = 0;

								if g_server ~= nil then
									g_server:broadcastEvent(SetCruiseControlSpeedEvent:new(self, self.cruiseControl.speed), nil, nil, self)
								else
									g_client:getServerConnection():sendEvent(SetCruiseControlSpeedEvent:new(self, self.cruiseControl.speed))
								end

								self.cruiseControl.speedSent = self.cruiseControl.speed
							end;
						else
							self.driveControl.cruiseControl.refVehicle = nil;
						end;
					else
						self.driveControl.cruiseControl.refVehicle = nil;
					end;
				end;			
			else
				self.driveControl.cruiseControl.refVehicle = nil;
			end;
		-- elseif g_currentMission.controlledVehicle == self then 
			-- if self.driveControl.cruiseControl.mode == self.driveControl.cruiseControl.MODE_MANUALVMAX then
				-- self.motor:setSpeedLimit(10) -- set to cruise value
				-- self.driveControl.cruiseControl.refVehicle = nil;
			-- end;
		end;
	end;
	
	
	
	
	if self.dCcheckModule ~= nil and self:dCcheckModule("cruiseControl") then
		if self:getIsActiveForInput(false) then
			if InputBinding.hasEvent(InputBinding.driveControlCruiseControlResetNextVehicle,true) then
				self.driveControl.cruiseControl.refVehicle = nil;
			end;
			if InputBinding.hasEvent(InputBinding.driveControlCruiseControlMode,true) then
				self.driveControl.cruiseControl.mode = self.driveControl.cruiseControl.mode + 1;
				if self.driveControl.cruiseControl.mode > self.driveControl.cruiseControl.MODE_MANUALVMAX then
					self.driveControl.cruiseControl.mode = 1;
				end;
				self:setCruiseControlState(0);
				self.driveControl.cruiseControl.refVehicle = nil;
				driveControlInputEvent.sendEvent(self)
			end;
		end;
	end;

		
	
	
	if g_gui.currentGuiName == nil or g_gui.currentGuiName == "" then
		self.driveControl.noEnterCnt = math.max(self.driveControl.noEnterCnt - 1,-1);
	else
		self.driveControl.noEnterCnt = 20;
	end;
	
		
	if self:getIsActiveForInput(false) or (g_currentMission.controlledVehicle == self and (g_gui.currentGuiName == nil or g_gui.currentGuiName == "")) then 
		if self.driveControl.noEnterCnt > 0 then
			return;
		end;
		--local rot,clutch,motorLoad = getMotorRotationSpeed(self.rootNode);
		--print(rot," ",clutch," ",motorLoad)
		-- print(self.motor.clutchRpm)
		-- self.motor.maxClutchTorque = 50000;
		if self.dCcheckModule ~= nil and self:dCcheckModule("fourWDandDifferentials") and not self.driveControl.fourWDandDifferentials.isSurpressed then
			if InputBinding.hasEvent(InputBinding.driveControl4WD) then
				self.driveControl.fourWDandDifferentials.fourWheel = not self.driveControl.fourWDandDifferentials.fourWheel;
				driveControlInputEvent.sendEvent(self)  
			end;
			
			if InputBinding.hasEvent(InputBinding.driveControlDiffLockFront) then
				self.driveControl.fourWDandDifferentials.diffLockFront = not self.driveControl.fourWDandDifferentials.diffLockFront;
				driveControlInputEvent.sendEvent(self) 
			end;
			
			if InputBinding.hasEvent(InputBinding.driveControlDiffLockBack) then
				self.driveControl.fourWDandDifferentials.diffLockBack = not self.driveControl.fourWDandDifferentials.diffLockBack;
				driveControlInputEvent.sendEvent(self) 
			end;
		end;
		
		
		
		
		
		
		
		-- if g_currentMission.driveControl.useModules.shuttle then
		if self.dCcheckModule ~= nil and self:dCcheckModule("shuttle") then
			if InputBinding.isPressed(InputBinding.driveControlShuttle) then
				self.driveControl.shuttle.onOffCnt = self.driveControl.shuttle.onOffCnt + dt;
			else
				self.driveControl.shuttle.onOffCnt = 0;
			end;
			if self.driveControl.shuttle.onOffCnt > 2500 or InputBinding.hasEvent(InputBinding.driveControlShuttleOnOff) then
				self.driveControl.shuttle.isActive = not self.driveControl.shuttle.isActive;
				self.driveControl.shuttle.onOffCnt = -100000000000000000000000;
				--print("shuttle turned ",self.driveControl.shuttle.isActive)				
				driveControlInputEvent.sendEvent(self) 
			end;
			
			
			
			if self.driveControl.shuttle.isActive then
				if InputBinding.hasEvent(InputBinding.driveControlShuttleForward) then
					if self.driveControl.shuttle.direction == 1.0 then
						if self.cruiseControl.state == Drivable.CRUISECONTROL_STATE_OFF then
	                        self:setCruiseControlState(Drivable.CRUISECONTROL_STATE_ACTIVE);
	                    else
	                        self:setCruiseControlState(Drivable.CRUISECONTROL_STATE_OFF);
	                    end;
					else
						self.driveControl.shuttle.direction = 1.0;						
						driveControlInputEvent.sendEvent(self)
					end;
				end;
				if InputBinding.hasEvent(InputBinding.driveControlShuttleBackward) then
					if self.driveControl.shuttle.direction == -1.0 then
						if self.cruiseControl.state == Drivable.CRUISECONTROL_STATE_OFF then
	                        self:setCruiseControlState(Drivable.CRUISECONTROL_STATE_ACTIVE);
	                    else
	                        self:setCruiseControlState(Drivable.CRUISECONTROL_STATE_OFF);
	                    end;
					else
						self.driveControl.shuttle.direction = -1.0;						
						driveControlInputEvent.sendEvent(self)
					end;
				end;
				if InputBinding.hasEvent(InputBinding.driveControlShuttle) then
					self.driveControl.shuttle.direction = -self.driveControl.shuttle.direction;						
					driveControlInputEvent.sendEvent(self)
				end;				
			end;
		end;
				
	end;
	
	self.driveControl.pipeCam.isActive = false;
	if self.dCcheckModule ~= nil and self:dCcheckModule("pipeCam") then
		local vehicle = self;
		if self.selectedImplement ~= nil and self.selectedImplement.object ~= nil and self.selectedImplement.object.attacherVehicle ~= nil and not self.isHired then
			vehicle = self.selectedImplement.object
		end;
		
		if vehicle.pipeRaycastNode ~= nil then
			if vehicle:getIsActiveForInput(true) then
				if vehicle.pipeCam == nil or vehicle.pipeCam == 0 then
					vehicle.pipeCam = createCamera("pipeCam", 90, 0.02, 100);
					link(vehicle.pipeRaycastNode, vehicle.pipeCam);
					rotate(vehicle.pipeCam,-math.pi/2,0,0);					
				end;
				
				
				
				local inputW = InputBinding.getDigitalInputAxis(InputBinding.AXIS_LOOK_UPDOWN_VEHICLE)+InputBinding.getAnalogInputAxis(InputBinding.AXIS_LOOK_UPDOWN_VEHICLE);
					
				vehicle.pipeCamShift = Utils.getNoNil(vehicle.pipeCamShift,1) + inputW*6e-3*dt;
				vehicle.pipeCamShift = Utils.clamp(vehicle.pipeCamShift,-5,5);
			
				
				if InputBinding.isPressed(InputBinding.driveControlPipeCam) then				
					local xW,yW,zW = getWorldTranslation(vehicle.pipeRaycastNode);
					local x,y,z = worldToLocal(vehicle.pipeRaycastNode,xW,yW+vehicle.pipeCamShift,zW)
					setTranslation(vehicle.pipeCam,x,y,z);					
					setCamera(vehicle.pipeCam);
					self.driveControl.pipeCam.isActive = true;					
				end;
				
			end;
		end;
	end;
	
end;







function driveControl:draw()
	if self.dCcheckModule ~= nil and self:dCcheckModule("showMotor") then
		if self.isMotorStarted  then
			if self.motorStartTime > g_currentMission.time then				
				driveControl.overlayPreHeat:render();
			end;
		else
			driveControl.overlayBattery:render();
		end;
	end;
	
	if self.dCcheckModule ~= nil and self:dCcheckModule("showNearestFillLevel") then
		
		setTextBold(false);
		setTextAlignment(RenderText.ALIGN_LEFT);
		setTextColor(0*0.6307, 0.6307, 0*0.6307, 1);
		
		local str
		
		if self.driveControl.cruiseControl.refVehicle~= nil and self.driveControl.cruiseControl.refVehicle.rootNode~= nil then
			local rootVehicle = self.driveControl.cruiseControl.refVehicle:getRootAttacherVehicle();
			
			local trailerFillLevel, trailerCapacity = 0,0;			
			if rootVehicle.getFillLevelInformation ~= nil then
				local fillLevelInformations = {}; --changed for LS17
				rootVehicle:getFillLevelInformation(fillLevelInformations);			
				for i,fillLevelInformation in pairs(fillLevelInformations) do
					trailerFillLevel = trailerFillLevel + fillLevelInformation.fillLevel;
					trailerCapacity = trailerCapacity + fillLevelInformation.capacity;				
				end
			end;
			
			local fL = 0;
			
			if trailerFillLevel~= nil and trailerCapacity~=nil then
				if trailerCapacity>0 then
					fL = trailerFillLevel/trailerCapacity;
				end;
			end;
			str = string.format("%.1f %%",fL*100);			
		else
			self.driveControl.cruiseControl.nearestCnt = Utils.getNoNil(self.driveControl.cruiseControl.nearestCnt,0)-1;
			if self.driveControl.cruiseControl.nearestCnt<0 then
				self.driveControl.cruiseControl.nearestCnt = 100;
				local nearestOther = driveControl.getNearestOther(self);
				self.driveControl.cruiseControl.nearestOther = nearestOther;
			elseif self.driveControl.cruiseControl.nearestOther~= nil then
				if self.driveControl.cruiseControl.nearestOther.rootNode~= nil then
					local rootVehicle = self.driveControl.cruiseControl.nearestOther:getRootAttacherVehicle();
					local trailerFillLevel, trailerCapacity = 0,0;			
					local fillLevelInformations = {}; --changed for LS17
					if rootVehicle.getFillLevelInformation~= nil then
						rootVehicle:getFillLevelInformation(fillLevelInformations);			
						for i,fillLevelInformation in pairs(fillLevelInformations) do
							trailerFillLevel = trailerFillLevel + fillLevelInformation.fillLevel;
							trailerCapacity = trailerCapacity + fillLevelInformation.capacity;				
						end
					end;
					
					local fL = 0;
					-- print(trailerFillLevel," ",trailerCapacity)
					if trailerFillLevel~= nil and trailerCapacity~=nil then
						if trailerCapacity>0 then
							fL = trailerFillLevel/trailerCapacity;
						end;
					end;
					str = string.format("%.1f %%",fL*100);	
				end;
			end;			
		end;
		
		if str ~= nil then
			renderText(driveControl.neighborFillLevelTxtX,driveControl.neighborFillLevelTxtY, driveControl.halfTextW,str);		
		end;
		setTextColor(1*0.6307, 0.6307, 1*0.6307, 1);
	end;
	

	if self.dCcheckModule ~= nil and self:dCcheckModule("cruiseControl") then
		if self.driveControl.cruiseControl.mode == self.driveControl.cruiseControl.MODE_STOP_FULL then
			driveControl.overlayCruiseStop100:render();
		elseif self.driveControl.cruiseControl.mode == self.driveControl.cruiseControl.MODE_STOP_EMPTY then
			driveControl.overlayCruiseStop0:render();
		elseif self.driveControl.cruiseControl.mode == self.driveControl.cruiseControl.MODE_PARALLEL then
			driveControl.overlayCruise_parallel:render();
		elseif self.driveControl.cruiseControl.mode == self.driveControl.cruiseControl.MODE_MANUALVMAX then
			driveControl.overlayCruise_vmax:render();
		end;
	end;
	
	if self.dCcheckModule ~= nil and self:dCcheckModule("freeSteering") then
		if self.driveControl.freeSteering.isActive then
			driveControl.overlayFreeSteering:render();
		end;
	end;
	

	-- if g_currentMission.driveControl.useModules.fourWDandDifferentials then
	if self.dCcheckModule ~= nil and self:dCcheckModule("fourWDandDifferentials") then
		if self.driveControl.fourWDandDifferentials.fourWheel then
			driveControl.overlay4WD:render();
		end;
		if self.driveControl.fourWDandDifferentials.diffLockFront then
			driveControl.overlayDiffLockFront:render();
		end;
		if self.driveControl.fourWDandDifferentials.diffLockBack then
			driveControl.overlayDiffLockBack:render();
		end;
	end;
	
	
	
	
	if self.dCcheckModule ~= nil and self:dCcheckModule("shuttle") then
	-- if g_currentMission.driveControl.useModules.shuttle then
		if self.driveControl.shuttle.isActive then
			if self.driveControl.shuttle.direction > 0 then
				driveControl.overlayArrowUp:render();
			else
				driveControl.overlayArrowDown:render();
			end;
		end;
	end;
				
end;

function driveControl:getSaveAttributesAndNodes(nodeIdent)
	
	local attributes = 'fourWheel="'..tostring(Utils.getNoNil(self.driveControl.fourWDandDifferentials.fourWheel,false))
	attributes = attributes..'" diffLockFront="'..tostring(Utils.getNoNil(self.driveControl.fourWDandDifferentials.diffLockFront,false))
	attributes = attributes..'" diffLockBack="'..tostring(Utils.getNoNil(self.driveControl.fourWDandDifferentials.diffLockBack,false))
		
	attributes = attributes ..'"';
	
	return attributes
end;

 

--function driveControl:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
-- function driveControl.loadSettingsFromXML(self)
	
	-- print("load dC parameters")
	--self.speedRotScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.speedRotScale#scale"), 80);
	
	-- self.driveControl.fourWDandDifferentials.fourWheel = Utils.getNoNil(getXMLBool(self.xmlFile, key.."#fourWheel"),false);
	-- self.driveControl.fourWDandDifferentials.diffLockFront = Utils.getNoNil(getXMLBool(self.xmlFile, key.."#diffLockFront"),false);
	-- self.driveControl.fourWDandDifferentials.diffLockBack = Utils.getNoNil(getXMLBool(self.xmlFile, key.."#diffLockBack"),false);
	
		
	-- if not resetVehicles then
		
	-- end;
	-- return BaseMission.VEHICLE_LOAD_OK;
-- end

function driveControl:writeStream(streamId, connection)
	streamWriteBool(streamId, g_currentMission.driveControl.useModules.shuttle);
	--streamWriteBool(streamId, g_currentMission.driveControl.useModules.manMotorStart);
	--streamWriteBool(streamId, g_currentMission.driveControl.useModules.gasAndGearLimiter);
	--streamWriteBool(streamId, g_currentMission.driveControl.useModules.hourCounter);
	streamWriteBool(streamId, g_currentMission.driveControl.useModules.fourWDandDifferentials);
	--streamWriteBool(streamId, g_currentMission.driveControl.useModules.handBrake);
	streamWriteBool(streamId, g_currentMission.driveControl.useModules.implementControl);
	streamWriteBool(streamId, g_currentMission.driveControl.useModules.freeSteering);
	
	streamWriteBool(streamId, self.driveControl.shuttle.isActive);
	streamWriteFloat32(streamId, self.driveControl.shuttle.direction);
	--streamWriteBool(streamId, self.driveControl.manMotorStart.isMotorStarted);
	--streamWriteFloat32(streamId, self.driveControl.gasGearLimiter.gasLimiter);
	--streamWriteFloat32(streamId, self.driveControl.gasGearLimiter.gearLimiter);
	--streamWriteFloat32(streamId, self.driveControl.hourCounter.hours);
	--streamWriteBool(streamId, self.driveControl.handBrake.isActive);
	
	streamWriteBool(streamId, self.driveControl.fourWDandDifferentials.isSurpressed);
	streamWriteBool(streamId, self.driveControl.fourWDandDifferentials.fourWheel);
	streamWriteBool(streamId, self.driveControl.fourWDandDifferentials.diffLockFront);
	streamWriteBool(streamId, self.driveControl.fourWDandDifferentials.diffLockBack);	
	
	streamWriteBool(streamId, self.driveControl.freeSteering.isActive);	
	
		
end;

function driveControl:readStream(streamId, connection) --sry, the server wins ;)
	
	g_currentMission.driveControl.useModules.shuttle = streamReadBool(streamId);
	--g_currentMission.driveControl.useModules.manMotorStart = streamReadBool(streamId);
	--g_currentMission.driveControl.useModules.gasAndGearLimiter = streamReadBool(streamId);
	--g_currentMission.driveControl.useModules.hourCounter = streamReadBool(streamId);
	g_currentMission.driveControl.useModules.fourWDandDifferentials = streamReadBool(streamId);
	--g_currentMission.driveControl.useModules.handBrake = streamReadBool(streamId);
	g_currentMission.driveControl.useModules.implementControl = streamReadBool(streamId);
	g_currentMission.driveControl.useModules.freeSteering = streamReadBool(streamId);
	
	local shuttleActive = streamReadBool(streamId);
	local shuttle = streamReadFloat32(streamId);
	--local isMotorStarted = streamReadBool(streamId);
	--local gasLimiter = streamReadFloat32(streamId);
	--local gearLimiter = streamReadFloat32(streamId);
	--local hours = streamReadFloat32(streamId);
	--local handBrake = streamReadBool(streamId);
	
	self.driveControl.shuttle.isActive = shuttleActive;
	self.driveControl.shuttle.direction = shuttle;
	--self.driveControl.manMotorStart.isMotorStarted = isMotorStarted;
	--self.driveControl.gasGearLimiter.gasLimiter = gasLimiter;
	--self.driveControl.gasGearLimiter.gearLimiter = gearLimiter;
	--self.driveControl.hourCounter.hours = hours;
	--self.driveControl.handBrake.isActive = handBrake;
	
	
	self.driveControl.fourWDandDifferentials.isSurpressed = streamReadBool(streamId);
	self.driveControl.fourWDandDifferentials.fourWheel = streamReadBool(streamId);
	self.driveControl.fourWDandDifferentials.diffLockFront = streamReadBool(streamId);
	self.driveControl.fourWDandDifferentials.diffLockBack = streamReadBool(streamId);
	
	self.driveControl.freeSteering.isActive = streamReadBool(streamId);
end;

function driveControl:delete()	
end

function driveControl.getAllConnectedVehicles(self)	
	local res = {};
	res[1] = self;	
	if self.attachedImplements ~= nil then
		if table.getn(self.attachedImplements) > 0 then			
			for k,implement in pairs(self.attachedImplements) do	
				-- print(implement.object.typeName)
				local returnValue = driveControl.getAllConnectedVehicles(implement.object);
				for kk,value in pairs(returnValue) do				
					table.insert(res,value)
				end;
			end;
		end;
	end;	
	return res;	
end





if Drivable.driveControlInstalled == nil then
	print("--- installing driveControl by upsidedown into Drivable, Steerable and VehicleMotor...")
	local oldFunc = Drivable.updateVehiclePhysics;
	function Drivable.updateVehiclePhysics(self, axisForward, axisForwardIsAnalog, axisSide, axisSideIsAnalog, doHandbrake, dt)
		local doBreakLight = axisForward > 0;
		
		
		local oldCruise = self.cruiseControl.state; --save this anyway
		if self.dCcheckModule ~= nil and self:dCcheckModule("shuttle") and self.driveControl.shuttle.isActive then --new code for shuttle
			
			self.cruiseControl.state = Drivable.CRUISECONTROL_STATE_OFF; --state is saved in local oldCruise above!
			
			local reverseFactor = 1.0;
			if self.driveControl.shuttle.reverseDirection then
				reverseFactor = -1.0;
			end;			
			
			if self.driveControl.shuttle.direction < 0 and (oldCruise == Drivable.CRUISECONTROL_STATE_OFF) then
				axisForward = -axisForward;
				self.axisForward = -self.axisForward;
			end;
			
			if self.movingDirection and self.movingDirection ~= self.driveControl.shuttle.direction*reverseFactor then
				if self.driveControl.shuttle.direction < 0 then
					axisForward = Utils.clamp(axisForward,0,1);			
				else
					axisForward = Utils.clamp(axisForward,-1,0);			
				end;
			end;
			--up to here everything without cruise is handled completely fine :)
			
			if oldCruise ~= Drivable.CRUISECONTROL_STATE_OFF then --now we have to handle cruise control while the original function believes vehicle is in manual mode:
				 if self.isMotorStarted and self.motorStartTime <= g_currentMission.time then
					if math.abs(axisForward) > 0.8 then
						oldCruise = -1; --reset cruise control, see code below that actually does that
					end;
					axisForward = -self.driveControl.shuttle.direction;
				 end;			
			end;
			
			if self.movingDirection == 0 then
				-- if math.random() < 0.5 then
					-- axisForward = 0;
				-- end
				self.hasStopped = true;
			end
		
		end
		
		
		
		
		
		if self.dCcheckModule ~= nil and self:dCcheckModule("softGas") then
			if self.driveControl.softGas.isOn then
				axisForward = axisForward * driveControl.softGasmaxGasOnModifier;
				axisForwardIsAnalog = true;
			end;
		end;
		
		if self.dCcheckModule ~= nil and self:dCcheckModule("freeSteering") then -- check module
			if self.driveControl.freeSteering.isActive then
				self.autoRotateBackSpeed = 0;
				if axisSideIsAnalog then
					if driveControl.freeSteeringDoSteerAnalog then
						local deadZone = driveControl.freeSteeringAnalogDeadZone
						if math.abs(axisSide) < deadZone then --increase deadzone
							axisSide = 0;
						else
							local neg = axisSide<0;
							axisSide = (math.abs(axisSide) - deadZone)/(1-deadZone);
							if neg then 
								axisSide = -axisSide;
							end;
						end;
					else
						axisSide = 0;
					end;
				end;
				axisSideIsAnalog = false;
			else
				self.autoRotateBackSpeed = self.driveControl.freeSteering.autoRotateBackSpeedBackup;
			end;
		end;
		
		
	
 
		--oldFunc(self, axisForward, axisForwardIsAnalog, axisSide, axisSideIsAnalog, false, dt)
		oldFunc(self, axisForward, axisForwardIsAnalog, axisSide, axisSideIsAnalog, doHandbrake, dt)
		
		if oldCruise == -1 then --reset cruise control to original state, handle turn off otherwise done by original function
			self:setCruiseControlState(Drivable.CRUISECONTROL_STATE_OFF, true);
		else
			self.cruiseControl.state = oldCruise; --reload this from possible changes
		end
		
		
		--begin of postFunc:
		
		
		if self.dCcheckModule ~= nil and self:dCcheckModule("shuttle") and self.driveControl.shuttle.isActive then
			self.setBrakeLightsVisibility(self, doBreakLight)				
			self.setReverseLightsVisibility(self, self.driveControl.shuttle.direction < 0);			
		end;		
				
	end;
	
	
	
	local oldVehicleGetSpeedLimit = Vehicle.getSpeedLimit;
	function Vehicle.getSpeedLimit(self,onlyIfWorking)
		local limit, doCheckSpeedLimit = oldVehicleGetSpeedLimit(self,onlyIfWorking)
		if self.dCcheckModule~= nil and self:dCcheckModule("cruiseControl") then
			if self.driveControl.cruiseControl.mode == self.driveControl.cruiseControl.MODE_MANUALVMAX then
				if self.cruiseControl.speed < limit then
					limit = self.cruiseControl.speed;
					doCheckSpeedLimit = true;
				end;
			end;
		end;
		
		return limit, doCheckSpeedLimit
	end;
	
	
	local oldgear = VehicleMotor.getBestGearRatio;
	function VehicleMotor.getBestGearRatio(self,wheelSpeedRpm, minRatio, maxRatio, accSafeMotorRpm, requiredMotorPower, requiredMotorRpm)
		if self.vehicle.dCcheckModule~= nil and self.vehicle:dCcheckModule("variGear") then
			local bestGearRatio = oldgear(self,wheelSpeedRpm, minRatio, maxRatio, accSafeMotorRpm, requiredMotorPower, requiredMotorRpm);
			local alpha = driveControl.variGearSmoothAlpha;			
			bestGearRatio = math.abs(self.gearRatio)*(1-alpha) + alpha*bestGearRatio;
			return bestGearRatio;
		else
			return oldgear(self,wheelSpeedRpm, minRatio, maxRatio, accSafeMotorRpm, requiredMotorPower, requiredMotorRpm);
		end;
	end;

	
			
	Drivable.driveControlInstalled = true;
end;



function driveControl.getNearestOther(self)
	local nearestOther = nil;
	local rootVehicle = self:getRootAttacherVehicle();
	local distance2 = 1e12;
	local x,y,z = getWorldTranslation(rootVehicle.rootNode);
	for kkk,steerable in pairs(g_currentMission.steerables) do
		if steerable ~= rootVehicle then
			local sx,sy,sz = getWorldTranslation(steerable.rootNode);
			local d2 = (sx-x)^2 + (sy-y)^2 + (sz-z)^2;
			if d2 < distance2 then
				nearestOther = steerable;
				distance2 = d2;
			end;
		end;
	end;
	return nearestOther;
end;
					
	







driveControlInputEvent = {};
driveControlInputEvent_mt = Class(driveControlInputEvent, Event);

InitEventClass(driveControlInputEvent, "driveControlInputEvent");

function driveControlInputEvent:emptyNew()
    local self = Event:new(driveControlInputEvent_mt);
    self.className="driveControlInputEvent";
    return self;
end;

function driveControlInputEvent:new(vehicle)
    local self = driveControlInputEvent:emptyNew()
    self.vehicle = vehicle;
	self.shuttleActive = vehicle.driveControl.shuttle.isActive
	self.shuttle = vehicle.driveControl.shuttle.direction;
	
	self.fourWheel = vehicle.driveControl.fourWDandDifferentials.fourWheel;
	self.diffLockFront = vehicle.driveControl.fourWDandDifferentials.diffLockFront;
	self.diffLockBack = vehicle.driveControl.fourWDandDifferentials.diffLockBack;
	
	
	self.cruiseMode = vehicle.driveControl.cruiseControl.mode
	self.softGas = vehicle.driveControl.softGas.isOn;
	
	self.freeSteering = vehicle.driveControl.freeSteering.isActive;
	-- print("event new")
    return self;
end;

function driveControlInputEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteBool(streamId, self.shuttleActive);
	streamWriteFloat32(streamId, self.shuttle);
	streamWriteBool(streamId, self.fourWheel);
	streamWriteBool(streamId, self.diffLockFront);
	streamWriteBool(streamId, self.diffLockBack);
	streamWriteIntN(streamId, self.cruiseMode,5);
	streamWriteBool(streamId, self.softGas);
	streamWriteBool(streamId, self.freeSteering);
	-- print("event writeStream")
end;

function driveControlInputEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
    local vehicle = networkGetObject(id);
	
	local shuttleActive = streamReadBool(streamId);
	local shuttle = streamReadFloat32(streamId);
	local fourWheel = streamReadBool(streamId);
	local diffLockFront = streamReadBool(streamId);
	local diffLockBack = streamReadBool(streamId);
	local cruiseMode = streamReadIntN(streamId,5);
	local softGas = streamReadBool(streamId);
	local freeSteering = streamReadBool(streamId);
	
	vehicle.driveControl.shuttle.isActive = shuttleActive;
	vehicle.driveControl.shuttle.direction = shuttle;
	vehicle.driveControl.fourWDandDifferentials.fourWheel = fourWheel;
	vehicle.driveControl.fourWDandDifferentials.diffLockFront = diffLockFront;
	vehicle.driveControl.fourWDandDifferentials.diffLockBack = diffLockBack;
	vehicle.driveControl.cruiseControl.mode = cruiseMode;
	vehicle.driveControl.softGas.isOn = softGas;
	vehicle.driveControl.freeSteering.isActive = freeSteering;
	-- print("event readStream")
	-- print(shuttleActive,shuttle,isMotorStarted,gasLimiter,gearLimiter)
	if g_server ~= nil then	
		g_server:broadcastEvent(driveControlInputEvent:new(vehicle), nil, nil, vehicle);
		-- print("broadcasting")
	end;
end;

function driveControlInputEvent.sendEvent(vehicle)
	if g_server ~= nil then	
		g_server:broadcastEvent(driveControlInputEvent:new(vehicle), nil, nil, vehicle);
		-- print("broadcasting")
	else
		g_client:getServerConnection():sendEvent(driveControlInputEvent:new(vehicle));
		-- print("sending event to server...")
	end;
end;



driveControlToggleImplementEvent = {}
driveControlToggleImplementEvent_mt = Class(driveControlToggleImplementEvent, Event)

InitEventClass(driveControlToggleImplementEvent, "driveControlToggleImplementEvent")

driveControlToggleImplementEvent.emptyNew = function (self)
	local self = Event:new(driveControlToggleImplementEvent_mt)

	return self
end
driveControlToggleImplementEvent.new = function (self, object, index)
	local self = driveControlToggleImplementEvent:emptyNew()
	self.object = object
	self.index = index

	return self
end
driveControlToggleImplementEvent.readStream = function (self, streamId, connection)
	self.object = networkGetObject(streamReadInt32(streamId))
	self.index = streamReadUIntN(streamId, 3)

	self.run(self, connection)

	return 
end
driveControlToggleImplementEvent.writeStream = function (self, streamId, connection)
	streamWriteInt32(streamId, networkGetObjectId(self.object))
	streamWriteUIntN(streamId, self.index, 3)

	return 
end
driveControlToggleImplementEvent.run = function (self, connection)
	driveControl.toggleAttacherJoint(self.object,self.index,true)
	if not connection.getIsServer(connection) then
		g_server:broadcastEvent(driveControlToggleImplementEvent:new(self.object, self.index), nil, connection, self.object)
	end

	return 
end






-- code taken with permission by Jakob Tischler from CP:
-- Giants - very intelligently - deletes any mod file in the savegame folder when saving. And now we get it back!

-- function disabled, this seems not to work anymore in LS17!!!

-- local function backupCpFiles(self)

	-- if g_server == nil and g_dedicatedServerInfo == nil then return end;

	-- if driveControl.savegameFolderPath == nil then return end;
	
		-- if not fileExists(driveControl.savegameFolderPath) then
			-- return;
		-- end;


	-- local savegameIndex = g_currentMission.missionInfo.savegameIndex;
	-- driveControl.cpTempSaveFolderPath = getUserProfileAppPath() .. 'dCBackupSavegame' .. savegameIndex;
	-- createFolder(driveControl.cpTempSaveFolderPath);

	-- driveControl.cpFileBackupPath = driveControl.cpTempSaveFolderPath .. '/driveControl_config.xml';
	-- copyFile(driveControl.savegameFolderPath, driveControl.cpFileBackupPath, true);

-- end;
-- g_careerScreen.saveSavegame = Utils.prependedFunction(g_careerScreen.saveSavegame, backupCpFiles);
 
-- local function getThatFuckerBack(self)

	-- if g_server == nil and g_dedicatedServerInfo == nil then return end;

	-- if not driveControl.cpFileBackupPath then return end;
	
	-- if driveControl.savegameFolderPath == nil then return end;

	-- local savegameIndex = g_currentMission.missionInfo.savegameIndex;
	-- local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
	-- if savegameFolderPath == nil then
		-- savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), savegameIndex);
	-- end;

	-- if fileExists(savegameFolderPath .. '/careerSavegame.xml') then -- savegame isn't corrupted and has been saved correctly

		-- copyFile(driveControl.cpFileBackupPath, driveControl.savegameFolderPath, true);
		-- driveControl.cpFileBackupPath = nil;


		-- deleteFolder(driveControl.cpTempSaveFolderPath);

	-- else -- corrupt savegame: display backup info message
		 
		-- local msgTitle = 'driveControl';
		-- local msgTxt = 'This savegame has been corrupted.';
		-- if driveControl.cpFieldsFileBackupPath then
			-- msgTxt = msgTxt .. ('\nYour driveControl files have been backed up to the %q directory.'):format('dCBackupSavegame' .. savegameIndex);
		-- else
			-- msgTxt = msgTxt .. ('\nYour driveControl file has been backed up to the %q directory.'):format('dCBackupSavegame' .. savegameIndex);
		-- end;
		-- msgTxt = msgTxt .. ('\n\nFull path: %q'):format(driveControl.cpTempSaveFolderPath);
		-- g_currentMission.inGameMessage:showMessage(msgTitle, msgTxt, 15000, false);
	-- end;

-- end;
-- g_careerScreen.saveSavegame = Utils.appendedFunction(g_careerScreen.saveSavegame, getThatFuckerBack); 